MTEXT mit entmake setzen / Lisp
romi1 26. Mrz. 2010, 11:36

Hallo!

Habe mir ein Lisp geschrieben, welche diverse Daten extrahiert und diese formatiert (mit Tabulatoren, ...) in die Variable "mtext-zeile" schreibt; diese Daten sollen dann zum Schluß als MTEXT mit entmake in die Zeichnung gesetzt werden:

Code:
  (entmake                                                                               
    (list
      (cons 0  "MTEXT")
      (cons 100  "AcDbEntity")
      (cons 100 "AcDbMText")
      (list '10 (car einsetzp) (cadr einsetzp))
      (cons 40 2.5)                                                                       
      (cons 41 250)
      (cons 1 mtext-zeile)
      (cons 50 0.0)
    )         
  )


Das funktioniert aber scheinbar nur dann, wenn die Variable "mtext-zeile" nicht zu viele Zeichen enthält. Wenn zu viele Zeichen in der Variable, wird einfach nichts ausgegeben - auch keine Fehlermeldung. Ich möchte aber auch längere Texte mit dieser Routine ausgeben; Wie kann ich das Problem beheben?

Gruß,
Roman

CADmium 26. Mrz. 2010, 11:41

Erstell einfach mal mit dem MText-Befehl so einen MText mit mehr als 255 Zeichen. und dann schau dir die Rückgabe von (entget(car(entsel))) mit Anwahl dieses Mtextes an .. besonders auf die GC1 und die GC3  

... und dann passe deinen Code entsprechend an. (und poste ihn hier)

oder du guckst dir die entsprechenden activeX methoden an ... da ist es etwas enfacher ( Den Textstring zu setzen)

romi1 27. Mrz. 2010, 14:07

Hallo!

Vielen Dank für den Tipp! Hab' das Lisp nun also folgendermaßen umgebaut, und es scheint zu funktionieren:

Code:
(setq li1                                                                               
    (list
      (cons 0  "MTEXT")
      (cons 100  "AcDbEntity")
      (cons 100 "AcDbMText")
      (list '10 (car einsetzp) (cadr einsetzp))
      (cons 40 2.5)                                                                       
      (cons 41 250)
      (cons 50 0.0)
    )
  )
  (if
    (< (strlen mtext-zeile) 250)
    (setq li2 (list (cons 1 mtext-zeile)))
    (progn
      (setq li2 ())
      (while
        (> (strlen mtext-zeile) 250)
        (setq li2        (cons (cons 3 (substr mtext-zeile 1 249)) li2)
              mtext-zeile (substr mtext-zeile 250)
        )
      )
      (setq li2 (reverse (cons (cons 1 mtext-zeile) li2)))
    )
  )
 
  (entmake (append li1 li2))